// ***********************************
// MÉTODOS DE ANÁLISIS DE ESTABILIDAD
// ***********************************
clear
// Se carga la librería de funciones para el diagrama de Bode sintótico.
// L librería debe estar en el directorio de operació. 
pth=pwd()
pth=pth+"\T_d_Control_lib.sci"
exec(pth)

xdel(winsid());
clc
// Transferencia
s=%s;
GH=syslin("c",5000,(s+1)*(s+50)*(s+100));
zpk(GH)
// Método de Routh Hurwitz
routh_t(GH,poly(0,"k"))
kpure(GH)
// Lugar de Raices
xdel(winsid());
evans(GH);
ch = gca().children;
curves = ch(2).children;
curves.thickness = 3;
asymptotes = ch(ch.type=="Segs");
asymptotes.segs_color = color("grey70");
xgrid(color("gray"));

// Diagramas de Bode
// Diagramas de Bode individuales
xdel(winsid())
wr=logspace(-2,4,500);
// Singularidades individuales
G1=syslin("c",5000,5000);
[M1,F1,w1]=bode_asym(G1,wr,2,"red");
subplot(211)
plot2d("ln",wr,M1,color("red"));
set_my_line_styles(1,2);
xgrid(color("gray"))
title("Diagrama de Bode de Módulo ")
ylabel("Ganancia [dB]")
subplot(212)
plot2d("ln",wr,F1,color("red"));
set_my_line_styles(1,2);
xgrid(color("gray"))
title("Diagrama de Bode de Fase")
ylabel("Fase [º]")
xlabel("Frecuencia [rad/seg]")

//figure("background",color("white"));
G1=syslin("c",1,s+1);
[M1,F1,w1]=bode_asym(G1,wr,2,"red");
subplot(211)
plot2d("ln",wr,M1,color("blue"));
set_my_line_styles(1,2);
xgrid(color("gray"))
title("Diagrama de Bode de Módulo ")
ylabel("Ganancia [dB]")
subplot(212)
plot2d("ln",wr,F1,color("blue"));
set_my_line_styles(1,2);
xgrid(color("gray"))
title("Diagrama de Bode de Fase")
ylabel("Fase [º]")
xlabel("Frecuencia [rad/seg]")
G1=syslin("c",1,s);

//figure("background",color("white"));
G1=syslin("c",1,1+s/50);
[M1,F1,w1]=bode_asym(G1,wr,2,"red");
subplot(211)
plot2d("ln",wr,M1,color("scilabgreen4"));
set_my_line_styles(1,2);
xgrid(color("gray"))
title("Diagrama de Bode de Módulo ")
ylabel("Ganancia [dB]")
subplot(212)
plot2d("ln",wr,F1,color("scilabgreen4"));
set_my_line_styles(1,2);
xgrid(color("gray"))
title("Diagrama de Bode de Fase")
ylabel("Fase [º]")
xlabel("Frecuencia [rad/seg]")

//figure("background",color("white"));
G1=syslin("c",1,1+s/100);
[M1,F1,w1]=bode_asym(G1,wr,2,"red");
subplot(211)
plot2d("ln",wr,M1,color("magenta"));
set_my_line_styles(1,2);
xgrid(color("gray"))
title("Diagrama de Bode de Módulo ")
ylabel("Ganancia [dB]")
subplot(212)
plot2d("ln",wr,F1,color("magenta"));
set_my_line_styles(1,2);
xgrid(color("gray"))
title("Diagrama de Bode de Fase")
ylabel("Fase [º]")
xlabel("Frecuencia [rad/seg]")

//Bode asintótico
xdel(winsid());
wr=logspace(-2,4,500);
[M1,F1,w1]=bode_asym(GH,wr,2,"red");
g_margin(GH)
F180=-180*ones(1,500);
xdel(winsid())
subplot(211)
plot2d("ln",wr,M1,color("blue"));
tipo_linea(1,2);
xgrid(color("gray"))
title("Diagrama de Bode de Módulo ")
ylabel("Ganancia [dB]")
subplot(212)
plot2d("ln",wr,F1,color("blue"));
tipo_linea(1,2);
plot(wr,F180,"--r");
xgrid(color("gray"))
title("Diagrama de Bode de Fase")
ylabel("Fase [º]")
xlabel("Frecuencia [rad/seg]")

// Nyquist Logarítmico
xdel(winsid())
nyquist(GH)
figure("BackgroundColor",[1 1 1]);
LogNyquist(GH,6,2);
Mod_inv(1.9375)


